#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

FILE	*infile,*outfile;
char	in_name[80],out_name[80];
char	nim[256],hbuf[256],dumpbuf[256]={'\0'};
int		ugchr[256],ugc=0;
long	size, adrs, exec;

void	main( int argc, char *argv[] );
void	openfile1(void);
void	openfile2(void);
void	closefile(void);
void	readheader(void);
void	disassemble(void);
int		get(void);
void	unget(int c);
char	*hx5(long c);
char	*hx4(long c);
char	*hx2(int c);
char	*reg1(int c);
char	*reg2(int c);
void	replace( char *s1,char *s2, char *s3 );
void	disasm(int c);
void	disp( char *s, int l );

static char *nim_tbl[256]=
{
    "NOP"           ,"RETI"          ,"JP mn"         ,"JPF lmn"       ,
    "CALL mn"       ,"CALLF lmn"     ,"RET"           ,"RETF"          ,
    "MV A,n"        ,"MV IL,n"       ,"MV BA,mn"      ,"MV I,mn"       ,
    "MV X,lmn"      ,"MV Y,lmn"      ,"MV U,lmn"      ,"MV S,lmn"      ,
    "JP (n)"        ,"JP r"          ,"JR +n"         ,"JR -n"         ,
    "JPZ mn"        ,"JPNZ mn"       ,"JPC mn"        ,"JPNC mn"       ,
    "JRZ +n"        ,"JRZ -n"        ,"JRNZ +n"       ,"JRNZ -n"       ,
    "JRC +n"        ,"JRC -n"        ,"JRNC +n"       ,"JRNC -n"       ,
    "???"           ,"PRE"           ,"PRE"           ,"PRE"           ,
    "PRE"           ,"PRE"           ,"PRE"           ,"PRE"           ,
    "PUSHU A"       ,"PUSHU IL"      ,"PUSHU BA"      ,"PUSHU I"       ,
    "PUSHU X"       ,"PUSHU Y"       ,"PUSHU F"       ,"PUSHU IMR"     ,
    "PRE"           ,"PRE"           ,"PRE"           ,"PRE"           ,
    "PRE"           ,"PRE"           ,"PRE"           ,"PRE"           ,
    "POPU A"        ,"POPU IL"       ,"POPU BA"       ,"POPU I"        ,
    "POPU X"        ,"POPU Y"        ,"POPU F"        ,"POPU IMR"      ,
    "ADD A,n"       ,"ADD (n),n"     ,"ADD A,(n)"     ,"ADD (n),A"     ,
    "ADD r,r"       ,"ADD r,r"       ,"ADD r,r"       ,"PMDF (n),n"    ,
    "SUB A,n"       ,"SUB (n),n"     ,"SUB A,(n)"     ,"SUB (n),A"     ,
    "SUB r,r"       ,"SUB r,r"       ,"SUB r,r"       ,"PUSHS F"       ,
    "ADC A,n"       ,"ADC (n),n"     ,"ADC A,(n)"     ,"ADC (n),A"     ,
    "ADCL (n),(n)"  ,"ADCL (n),A"    ,"MVL (m),[r]"   ,"PMDF (n),A"    ,
    "SBC A,n"       ,"SBC (n),n"     ,"SBC A,(n)"     ,"SBC (n),A"     ,
    "SBCL (n),(n)"  ,"SBCL (n),A"    ,"MVL [r],(m)"   ,"POPS F"        ,
    "CMP A,n"       ,"CMP (n),n"     ,"CMP [klm],n"   ,"CMP (n),A"     ,
    "TEST A,n"      ,"TEST (n),n"    ,"TEST [klm],n"  ,"TEST (n),A"    ,
    "XOR A,n"       ,"XOR (n),n"     ,"XOR [klm],n"   ,"XOR (n),A"     ,
    "INC r"         ,"INC (n)"       ,"XOR (n),(n)"   ,"XOR A,(n)"     ,
    "AND A,n"       ,"AND (n),n"     ,"AND [klm],n"   ,"AND (n),A"     ,
    "MV A,B"        ,"MV B,A"        ,"AND (n),(n)"   ,"AND A,(n)"     ,
    "OR A,n"        ,"OR (n),n"      ,"OR [klm],n"    ,"OR (n),A"      ,
    "DEC r"         ,"DEC (n)"       ,"OR (n),(n)"    ,"OR A,(n)"      ,
    "MV A,(n)"      ,"MV IL,(n)"     ,"MV BA,(n)"     ,"MV I,(n)"      ,
    "MV X,(n)"      ,"MV Y,(n)"      ,"MV U,(n)"      ,"MV S,(n)"      ,
    "MV A,[lmn]"    ,"MV IL,[lmn]"   ,"MV BA,[lmn]"   ,"MV I,[lmn]"    ,
    "MV X,[lmn]"    ,"MV Y,[lmn]"    ,"MV U,[lmn]"    ,"MV S,[lmn]"    ,
    "MV A,[r]"      ,"MV IL,[r]"     ,"MV BA,[r]"     ,"MV I,[r]"      ,
    "MV X,[r]"      ,"MV Y,[r]"      ,"MV U,[r]"      ,"SC"            ,
    "MV A,[(n)]"    ,"MV IL,[(n)]"   ,"MV BA,[(n)]"   ,"MV I,[(n)]"    ,
    "MV X,[(n)]"    ,"MV Y,[(n)]"    ,"MV U,[(n)]"    ,"RC"            ,
    "MV (n),A"      ,"MV (n),IL"     ,"MV (n),BA"     ,"MV (n),I"      ,
    "MV (n),X"      ,"MV (n),X"      ,"MV (n),U"      ,"MV (n),S"      ,
    "MV [lmn],A"    ,"MV [lmn],IL"   ,"MV [lmn],BA"   ,"MV [lmn],I"    ,
    "MV [lmn],X"    ,"MV [lmn],Y"    ,"MV [lmn],U"    ,"MV [lmn],S"    ,
    "MV [r],A"      ,"MV [r],IL"     ,"MV [r],BA"     ,"MV [r],I"      ,
    "MV [r],X"      ,"MV [r],Y"      ,"MV [r],U"      ,"CMP (m),(n)"   ,
    "MV [(n)],A"    ,"MV [(n)],IL"   ,"MV [(n)],BA"   ,"MV [(n)],I"    ,
    "MV [(n)],X"    ,"MV [(n)],Y"    ,"MV [(n)],U"    ,"???"           ,
    "EX (m),(n)"    ,"EXW (m),(n)"   ,"EXP (m),(n)"   ,"EXL (m),(n)"   ,
    "DADL (m),(n)"  ,"DADL (m),A"    ,"CMPW (m),(n)"  ,"CMPP (m),(n)"  ,
    "MV (m),(n)"    ,"MVW (m),(n)"   ,"MVP (m),(n)"   ,"MVL (m),(n)"   ,
    "MV (m),n"      ,"MVW (l),mn"    ,"TCL"           ,"MVLD (m),(n)"  ,
    "MV (k),[lmn]"  ,"MVW (k),[lmn]" ,"MVP (k),[lmn]" ,"MVL (k),[lmn]" ,
    "DSBL (m),(n)"  ,"DSBL (n),A"    ,"CMPW (n),r"    ,"CMPP (n),r"    ,
    "MV [klm],(n)"  ,"MVW [klm],(n)" ,"MVP [klm],(n)" ,"MVL [klm],(n)" ,
    "MVP (k),lmn"   ,"EX A,B"        ,"HALT"          ,"OFF"           ,
    "MV (n),[r]"    ,"MVW (n),[r]"   ,"MVP (n),[r]"   ,"MVL (n),[r]"   ,
    "ROR A"         ,"ROR (n)"       ,"ROL A"         ,"ROL (n)"       ,
    "MV [r],(m)"    ,"MVW [r],(m)"   ,"MVP [r],(m)"   ,"MVL [r],(m)"   ,
    "DSLL (n)"      ,"EX r,r"        ,"SWAP A"        ,"WAIT"          ,
    "MV (m),[(n)]"  ,"MVW (m),[(n)]" ,"MVP (m),[(n)]" ,"MVL (m),[(n)]" ,
    "SHR A"         ,"SHR (n)"       ,"SHL A"         ,"SHL (n)"       ,
    "MV [(m)],(n)"  ,"MVW [(m)],(n)" ,"MVP [(m)],(n)" ,"MVL [(m)],(n)" ,
    "DSRL (n)"      ,"MV r,r"        ,"IR"            ,"RESET"         ,
};


static char *pre_tbl[]=
{
	"PRE (BP+m),(BP+PY)" ,
	"PRE (BP+m),(n)"     ,
	"PRE (BP+m),(PY+n)"  ,
	"PRE (BP+PX),(BP+n)" ,
	"PRE (BP+PX),(BP+PY)",
	"PRE (BP+PX),(n)"    ,
	"PRE (BP+PX),(PY+n)" ,
	"PRE (m),(BP+n)"     ,
	"PRE (m),(BP+PY)"    ,
	"PRE (m),(n)"        ,
	"PRE (m),(PY+n)"     ,
	"PRE (PX+m),(BP+n)"  ,
	"PRE (PX+m),(BP+PY)" ,
	"PRE (PX+m),(n)"     ,
	"PRE (PX+m),(PY+n)"  ,
};

static char *reg_tbl[]=
{
	"A",	"IL",	"BA",	"I",
	"X",	"Y",	"U",	"S",
	"Reg?",	"Reg?",	"Reg?",	"Reg?",
	"Reg?",	"Reg?",	"Reg?",	"Reg?",
};

void	main( int argc, char *argv[] )
{
	int i;
	printf("<<< Disassembler for ESR-L Version 1.2  (c)1995-1996 E.Kako >>>\n");
	if (argc!=2) printf("Usage: disasm filename\n"),exit(1);
	strcpy(in_name,argv[1]);
	if (strchr(in_name,'.')==NULL) strcat(in_name,".obj");
	strcpy(out_name,in_name);
	for (i=0;i<strlen(out_name);i++) if (out_name[i]=='.') out_name[i]='\0';
	strcat(out_name,".dis");
	
	printf("Input file  : %s\n",in_name);
	openfile1();
	readheader();
	
	printf("Output file : %s\n",out_name);
	openfile2();
	disassemble();
	
	closefile();
}

void	openfile1(void)
{
	if ((infile=fopen(in_name, "rb"))==NULL)
		printf("%s cannot open.\n",in_name),exit(1);
}

void	openfile2(void)
{
	if ((outfile=fopen(out_name, "w"))==NULL)
		printf("Error: %s cannot create.\n",out_name),exit(1);
}

void	closefile(void)
{
	fclose(infile);
	fclose(outfile);
}

void	readheader(void)
{
	int		buf[16],i;
	for (i=0;i<16;i++) { buf[i]=getc(infile); }
	if ( (buf[0]==0xFF)&&(buf[1]==0x00)&&(buf[2]==0x06)&&(buf[3]==0x01)&&
		 (buf[4]==0x10)&&(buf[14]==0x00)&&(buf[15]==0x0F) ) {
				size=(long)buf[5]+256L*(long)buf[6]+65536L*(long)buf[7];
				adrs=(long)buf[8]+256L*(long)buf[9]+65536L*(long)buf[10];
	} else {
		printf("Error: Illegal header.\n"); exit(1);
	}
}

void	disassemble(void)
{
	int c;
	printf("\n");
	printf("Now working...\n");
	fprintf(outfile,";                 Filename: %s\n" , in_name );
	fprintf(outfile,";                 ORG: %s\n" , hx5(adrs) );
	
	while (1) {
		if ( (c=get()) == -1 ) break;
		disasm(c);
	}
	
	fprintf(outfile,";                 END\n");
	printf("Completed.\n");
}

int		get(void)
{
	int		c;
	c = ( (ugc==0) ? getc(infile) : ugchr[--ugc] );
	sprintf(hbuf,"%02X",c);
	strcat(dumpbuf,hbuf);
	return c;
}

void	unget(int c)
{
	ugchr[ugc++]=c;
}

char	*hx5(long c)
{
	sprintf( hbuf,"%1lX%04lXh", c>>16 , c&0xFFFF );
	return hbuf;
}

char	*hx4(long c)
{
	sprintf(hbuf,"%04lXh",c);
	return hbuf;
}

char	*hx2(int c)
{
	sprintf(hbuf,"%02Xh",c);
	return hbuf;
}

char	*reg1(int c)
{
	sprintf(hbuf,"%s",reg_tbl[c&0x0F] );
	return hbuf;
}

char	*reg2(int c)
{
	sprintf(hbuf,"%s",reg_tbl[ (c&0xF0)>>4 ] );
	return hbuf;
}

void	replace( char *s1,char *s2, char *s3 )
{
	char	tmp1[80],tmp2[80];
	int		i,n=-1;
	strcpy(tmp1,s1);
	for (i=0;i<strlen(tmp1);i++) {
		if (strncmp( tmp1+i , s2 , strlen(s2) )==0) {
			n=i; break;
		}
	}
	if (n>=0) {
		strcpy( tmp2 , tmp1 ); tmp2[n]='\0';
		strcat( tmp2 , s3 );
		strcat( tmp2 , tmp1+n+strlen(s2) );
		strcpy(s1,tmp2);
	}
}

void	disasm(int c)
{
	char	nbuf[80];
	strcpy(nim,nim_tbl[c]);
	if (strcmp(nim,"PRE")==0) {
		if (c<0x29) { c -= 0x20; } else { c-= 0x28; }
		strcpy(nim,pre_tbl[c-1]);
		strcpy(nbuf,nim);
		dumpbuf[2]='\0';
		replace( nbuf , " " , "\t" );
		fprintf(outfile,"%s ",hx5(adrs));
		fprintf(outfile,"%-10s ",dumpbuf);
		fprintf(outfile,"%s\n",nbuf);
		dumpbuf[0]='\0';
		adrs++;
		return;
	}
	disp(nim,1);
}

void	disp( char *s, int l )
{
	char	nbuf[80];
	long	c1,c2,c3,i;
	strcpy(nbuf,s);
	
	
	/* preprocess */
	if (strstr(nbuf,"[r]")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		switch (c1 & 0xF0) {
			case 0x00: replace( nbuf , "[r]" , "[r]"   ); break;
			case 0x20: replace( nbuf , "[r]" , "[r++]" ); break;
			case 0x30: replace( nbuf , "[r]" , "[--r]" ); break;
			case 0x80: replace( nbuf , "[r]" , "[r+n]" ); break;
			case 0xC0: replace( nbuf , "[r]" , "[r-n]" ); break;
			default:   replace( nbuf , "[r]" , "[?r]"   ); break;
		}
		replace( nbuf , "r" , reg1(c1) );
		l+=1;
	} else if ((strstr(nbuf,"CMPP")!=NULL)&&
					(strstr(nbuf,"r")!=NULL)) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "r" , reg1(c1) );
		l+=1;
	} else if ((strstr(nbuf,"CMPW")!=NULL)&&
					(strstr(nbuf,"r")!=NULL)) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "r" , reg1(c1) );
		l+=1;
	} else if (strstr(nbuf,"r,r")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "r" , reg2(c1) );
		replace( nbuf , "r" , reg1(c1) );
		l+=1;
	} else if (strstr(nbuf,"[(m)]")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		switch (c1) {
			case 0x00: replace( nbuf , "[(m)]" , "[(m)]"   ); break;
			case 0x80: replace( nbuf , "[(m)]" , "[(m)+o]"   ); break;
			case 0xC0: replace( nbuf , "[(m)]" , "[(m)-o]"   ); break;
			default:   replace( nbuf , "[(m)]" , "[?(m)]"   ); break;
		}
		l+=1;
	} else if (strstr(nbuf,"[(n)]")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		switch (c1) {
			case 0x00: replace( nbuf , "[(n)]" , "[(n)]"   ); break;
			case 0x80: replace( nbuf , "[(n)]" , "[(n)+o]"   ); break;
			case 0xC0: replace( nbuf , "[(n)]" , "[(n)-o]"   ); break;
			default:   replace( nbuf , "[(n)]" , "[?(n)]"   ); break;
		}
		l+=1;
	}
	
	/* first operand */
	if (strstr(nbuf,"(k)")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "k" , hx2(c1) );
		l+=1;
	} else if (strstr(nbuf,"(l)")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "l" , hx2(c1) );
		l+=1;
	} else if (strstr(nbuf,"(m)")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "m" , hx2(c1) );
		l+=1;
	} else if (strstr(nbuf,"klm")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		c2=get(); if (c2<0) c2=0;
		c3=get(); if (c3<0) c3=0;
		replace( nbuf , "klm" , hx5(c1+c2*256L+c3*65536L) );
		l+=3;
	} else if (strstr(nbuf,"lmn")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		c2=get(); if (c2<0) c2=0;
		c3=get(); if (c3<0) c3=0;
		replace( nbuf , "lmn" , hx5(c1+c2*256L+c3*65536L) );
		l+=3;
	} else if (strstr(nbuf,"mn")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		c2=get(); if (c2<0) c2=0;
		replace( nbuf , "mn" , hx4(c1+c2*256) );
		l+=2;
	} else if (strstr(nbuf,"(n)")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "n" , hx2(c1) );
		l+=1;
	} else if (strstr(nbuf,"n")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "n" , hx2(c1) );
		l+=1;
	}
	
	/* second operand */
	if (strstr(nbuf,"(m)")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "m" , hx2(c1) );
		l+=1;
	} else if (strstr(nbuf,"lmn")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		c2=get(); if (c2<0) c2=0;
		c3=get(); if (c3<0) c3=0;
		replace( nbuf , "lmn" , hx5(c1+c2*256L+c3*65536L) );
		l+=3;
	} else if (strstr(nbuf,"mn")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		c2=get(); if (c2<0) c2=0;
		replace( nbuf , "mn" , hx4(c1+c2*256) );
		l+=2;
	} else if (strstr(nbuf,"m")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "m" , hx2(c1) );
		l+=1;
	} else if (strstr(nbuf,"(n)")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "n" , hx2(c1) );
		l+=1;
	} else if (strstr(nbuf,"n")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "n" , hx2(c1) );
		l+=1;
	} else if (strstr(nbuf,"r")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "r" , reg1(c1) );
		l+=1;
	}
	
	/*  for some special case */
	if (strstr(nbuf,"n")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "n" , hx2(c1) );
		l+=1;
	} else if (strstr(nbuf,"o")!=NULL) {
		c1=get(); if (c1<0) c1=0;
		replace( nbuf , "o" , hx2(c1) );
		l+=1;
	}
	
	dumpbuf[l*2]='\0';
	replace( nbuf , " " , "\t" );
	
	fprintf(outfile,"%s ",hx5(adrs));
	fprintf(outfile,"%-10s ",dumpbuf);
	fprintf(outfile,"%s\n",nbuf);
	adrs+=l;
	dumpbuf[0]='\0';
}

